(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 1997-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: og_config.mli,v 1.4 2014/01/31 09:51:52 fclement Exp $ *)

val set_keep_comments : bool -> unit;;
val get_keep_comments : unit -> bool;;

val set_keep_type_definitions : bool -> unit;;
val get_keep_type_definitions : unit -> bool;;

val set_input_file_name : Og_file.file_name -> unit;;
val get_input_file_name : unit -> Og_file.file_name;;
val get_input_module_name : unit -> Og_file.file_name;;
val set_output_file_name : Og_file.file_name -> unit;;
val get_output_file_name : unit -> Og_file.file_name;;
val set_anonymous_file_name : Og_file.file_extension -> Og_file.file_name -> unit;;
val get_anonymous_file_name : unit -> Og_file.file_name option;;
val get_input_output_file_names : unit -> (Og_file.file_name * Og_file.file_name);;

val set_ignore_explicit_alias : bool -> unit;;
val get_ignore_explicit_alias : unit -> bool;;

val print_short_version : unit -> unit;;
val print_full_version : unit -> unit;;
