(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 1997-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: action_spec.mli,v 1.8 2014/01/31 09:51:52 fclement Exp $ *)

(* Walk a type definition to generate matching functions for this type. *)

(* The type of functions to call in expression parts of functions generated
  by the walkers. *)

module type Action =

sig

  val sum_tag : Walker_ast.sum_label -> unit

  val begin_sum_inj : Walker_ast.sum_label -> unit
  val end_sum_inj : Walker_ast.sum_label -> unit

  val begin_tuple : unit -> unit
    val begin_tuple_elem : unit -> unit
    val end_tuple_elem : unit -> unit
    val separator_tuple : unit -> unit
  val end_tuple : unit -> unit

  val begin_record_expr : unit -> unit
  val end_record_expr : unit -> unit

  val begin_record_field : Walker_ast.record_label -> unit
  val end_record_field : Walker_ast.record_label -> unit

  val begin_application : unit -> unit
    val separator_argument : unit -> unit
    val begin_argument : unit -> unit
    val end_argument : unit -> unit
  val end_application : unit -> unit

  val begin_paren : unit -> unit
  val end_paren : unit -> unit

  val external_fun : Walker_ast.name -> unit

end
;;

module type T = Action
;;

module type Make =
  functor (Io : Walk_spec.Out) -> Action
;;
