(***********************************************************************)
(*                                                                     *)
(*                              OCamlGen                               *)
(*                                                                     *)
(*                       OCaml module Generator                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 1997-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: walker_spec.mli,v 1.8 2014/01/31 09:51:52 fclement Exp $ *)

(* Walk a type definition to generate matching functions for this type. *)

module type Walker =

sig

  val file : Walker_ast.file -> unit
  ;;

end
;;

module type T = Walker
;;

module type Make =
  functor (S : Walk_spec.Make) ->
  functor (U : Action_spec.Make) ->
  functor (Io : Walk_spec.Out) ->
  Walker
;;
